import charactersJSON from './characters.json'
import { Collection } from 'discord.js'

export enum Target {
    Self = "self",
    Team = "team",
    OneTeammate = "oneTeammate",
    OneOpponent = "oneOpponent",
    AllOpponents = "allOpponents",
    TrueRandomOpponent = "trueRandomOpponent"
}

export interface PotencyStatus {
    duration: number
    potency: number
}

interface Effect {
    target: Target
    accuracy?: number
    damage?: number
    heal?: number
    poison?: number
    regeneration?: number
    burn?: number
    confusion?: number
    stun?: number
    resistanceChange?: PotencyStatus
    accuracyChange?: PotencyStatus
    speedChange?: PotencyStatus
    function?: string
}

interface Skill {
    name: string
    accuracy?: number
    effects: Effect[]
}

export interface Character {
    id: number
    name: string
    nameShort: string
    img: string
    health: number
    speed: number
    skills: [Skill, Skill, Skill]
}

export const CHARACTERS: Collection<number, Character> = new Collection(charactersJSON.map((element, index) => {return [index, element as Character]}));